/*  
 *  snake3d, a snake game in a 3d world.
 *  Copyright (C) 2005-2006 Yair Yarom
 *  
 *  This program is free software; you can redistribute it and/or modify it under
 *  the terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option) any later
 *  version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along with
 *  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *  Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 *  http://sourceforge.net/projects/worms3d
 *  
 */

#ifndef FUNCTIONS_HPP
#define FUNCTIONS_HPP

#include "includes.hpp"
#include "global.hpp"

double distance(int* pointA, int* pointB);
bool deadEnd(occupancy_t occupancy);
int drawString(GLfloat x, GLfloat y, GLfloat z, char *string);
int drawString(GLfloat x, GLfloat y, const char *string);
void drawColoredString(GLfloat x, GLfloat y, const char *string);
void drawChar(GLfloat x, GLfloat y, GLfloat z, char character);
void drawChar(GLfloat x, GLfloat y, char character);
void drawInt(GLfloat x , GLfloat y, GLfloat z, int integer);
void drawInt(GLfloat x , GLfloat y, int integer);
void drawStroke(GLfloat x, GLfloat y, GLfloat z, char *text);
void drawScreen(bool lines);
void loadPerspectives();
void reshape();
void drawboard(bool first);
void switchFullScreen();
void emptyState();
void quit();
void quit(int status);
bool keyPressed(SDL_keysym pressed, keys_t key);
char* keyString(keys_t k, char* str);
void speedUp();
void speedDown();
Uint32 timer(Uint32 interval, void* value);
void globalTick(int times);
bool updateKeyPressed(SDL_keysym* key);
void step(int* oldLocation, direction dir, int* newLocation);
void resetNames();
inline void colorIt(int color) {glColor3fv(COLORS[color]);};

#endif
