/*  
 *  snake3d, a snake game in a 3d world.
 *  Copyright (C) 2005-2006 Yair Yarom
 *  
 *  This program is free software; you can redistribute it and/or modify it under
 *  the terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option) any later
 *  version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along with
 *  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *  Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 *  http://sourceforge.net/projects/worms3d
 *  
 */

#include "global.hpp"
#include "preferences.hpp"

/* general */

//int backgroundColor = BROWN;

//int stepInterval = DEFAULT_STEP_INTERVAL;
long timerLong = 0;
float stepPercent = 0;
//int gameModeValue = 0;
int fineTuneSpeed = 0;
bool recentSpeedChange = false;

Board* mainBoard = NULL;
Snake* player;
//int playerID;
State* state = NULL;
Snake* snakes[MAX_SNAKES];
char names[MAX_SNAKES][20];

playMode_t p_mode;
//bool lightingEnabled = true;
bool redisplay;

/* window */
//int windowSize[] = {800, 600};

//float fieldOfView = INIT_FIELD_OF_VIEW;
//int currentWindow;
int nResolutions = 0;
int** resolutions = NULL;
int defaultResolution = 0;

/* snake */
GLUquadric* cylinder = 0;

float JOINT_BENDS[9][3];

float BEND_NORMALS[9][3];

/* board */

//int gridLevel1 = 3;
//int gridLevel3 = 1;
//bool showWalls = true;
bool paused = false;
//Board* BOARDS[NBOARDS];
int nBoardsTypes = 0;
int* nBoards; // [nBoardsTypes]
Board*** boardPrototype; // [nBoardsTypes][nBoards]
int* boardsDefaultSize;


Preferences prefs;

/* matrices */
//float boardRotationMatrix[16];
float thirdPersonProjectionMatrix[16];
float firstPersonProjectionMatrix[16];
float compassProjectionMatrix[16];
float screenProjectionMatrix[16];
float viewProjectionMatrix[16];

/* keyboard */
/*
char keyMovement[] = {'4','2','6','8','9','3'};
char keySelfMovement[] = {'j',',','l','i'};
char keySelfYaw[] = {'m','.'};
char keyBoardRotate[] = {'a','x','d','w'};
char keyBoardYaw[] = {'z','c'};
char keyZoomIn = '=';
char keyZoomOut = '-';
char keyGrid1 = 'G';
char keyGrid3 = 'g';
char keyAutoPilot = 'n';
char keyQuit = 'q';
char keyResetBoard = 'r';
char keyResetSnakes = 'R';
char keyBackgroundColor = 'b';
char keySpeedUp = '>';
char keySpeedDown = '<';
char keyShowWalls = 'e';
char keyFullScreen = 'f';
char keyLighting = 't';
char keyPause = 'p';
*/

//char keys[NKEYS];
//int keysMod[NKEYS];

/* //moved into DEFAULT_KEYS
    '4',  //  k_moveLeft,
    '2',  //  k_moveDown,		      
    '6',  //  k_moveRight,	      
    '8',  //  k_moveUp,		      
    '9',  //  k_moveForward,	      
    '3',  //  k_moveBackward,	      
    'j',  //  k_selfMoveLeft,	      
    ',',  //  k_selfMoveDown,	      
    'l',  //  k_selfMoveRight,	      
    'i',  //  k_selfMoveUp,	      
    'm',  //  k_selfYawLeft,	      
    '.',  //  k_selfYawRight,	      
    'a',  //  k_boardRotateLeft,	      
    'x',  //  k_boardRotateDown,	      
    'd',  //  k_boardRotateRight,	      
    'w',  //  k_boardRotateUp,	      
    'z',  //  k_boardYawLeft,	      
    'c',  //  k_boardYawRight,	      
    '=',  //  k_zoomIn,		      
    '-',  //  k_zoomOut,		      
    'G',  //  k_grid1,		      
    'g',  //  k_grid3,		      
    'n',  //  k_autoPilot,	      
    'r',  //  k_resetBoard,	      
    'R',  //  k_resetSnakes,	      
    'b',  //  k_backgroundColor,	      
    '>',  //  k_speedUp,		      
    '<',  //  k_speedDown,	      
    'e',  //  k_showWalls,	      
    'f',  //  k_fullScreen,	      
    (char)0,  //  k_lighting,		      
    'p',  //  k_pause,		      
    'q'	  //  k_quit                    
};
*/
