/*  
 *  snake3d, a snake game in a 3d world.
 *  Copyright (C) 2005-2006 Yair Yarom
 *  
 *  This program is free software; you can redistribute it and/or modify it under
 *  the terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option) any later
 *  version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along with
 *  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *  Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 *  http://sourceforge.net/projects/worms3d
 *  
 */

#ifndef GLOBAL_HPP
#define GLOBAL_HPP

#include "includes.hpp"
#include "consts.hpp"

class Board;
class Snake;

/* general */

//extern int backgroundColor;

//extern int stepInterval;
extern long timerLong;
//extern int gameModeValue;
extern float stepPercent;
extern int fineTuneSpeed;
extern bool recentSpeedChange;

extern Board* mainBoard;
extern Snake* player;
extern Snake* snakes[MAX_SNAKES];
//extern int playerID;
extern State* state;
extern char names[MAX_SNAKES][20];

extern playMode_t p_mode;

extern bool redisplay;

/* window */
//extern int windowSize[];

//extern float fieldOfView;
//extern int currentWindow;

extern int nResolutions;
extern int** resolutions;
extern int defaultResolution;

/* snake */

extern GLUquadric* cylinder;
extern float JOINT_BENDS[][3];
extern float BEND_NORMALS[][3];

/* board */
//extern int gridLevel1;
//extern int gridLevel3;
//extern bool showWalls;
extern bool paused;
//extern Board* BOARDS[NBOARDS];
extern int nBoardsTypes;
extern int* nBoards; // [nBoardsTypes]
extern Board*** boardPrototype; // [nBoardsTypes][nBoards]
extern int* boardsDefaultSize;

extern Preferences prefs;

/* matrices */
//extern float boardRotationMatrix[];
extern float thirdPersonProjectionMatrix[];
extern float firstPersonProjectionMatrix[];
extern float compassProjectionMatrix[];
extern float screenProjectionMatrix[];
extern float viewProjectionMatrix[];

/* keyboard */
/*
extern char keyMovement[];
extern char keySelfMovement[];
extern char keySelfYaw[];
extern char keyBoardRotate[];
extern char keyBoardYaw[];
extern char keyZoomIn;
extern char keyZoomOut;
extern char keyGrid1;
extern char keyGrid3;
extern char keyAutoPilot;
extern char keyQuit;
extern char keyResetBoard;
extern char keyResetSnakes;
extern char keyBackgroundColor;
extern char keySpeedUp;
extern char keySpeedDown;
extern char keyShowWalls;
extern char keyFullScreen;
extern char keyLighting;
extern char keyPause;
*/

//extern char keys[NKEYS];
//extern int keysMod[NKEYS];

#endif
