/*  
 *  snake3d, a snake game in a 3d world.
 *  Copyright (C) 2005-2006 Yair Yarom
 *  
 *  This program is free software; you can redistribute it and/or modify it under
 *  the terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option) any later
 *  version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along with
 *  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *  Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 *  http://sourceforge.net/projects/worms3d
 *  
 */

#ifndef PACKTES_HPP
#define PACKTES_HPP

#include "types.hpp"

#if (defined __APPLE__ && defined __MACH__)
#include <SDL_net/SDL_net.h>
#else
#include <SDL_net.h>
#endif
//extern SDL_mutex* netLock;
extern SDL_sem* netLock;

static const unsigned char ASSIGN_PACKET       	   = 1;
static const unsigned char SNAKE_CONFIG_PACKET 	   = 2;
static const unsigned char BOARD_CONFIG_PACKET 	   = 3;
static const unsigned char START_PACKET        	   = 4;
static const unsigned char STOP_PACKET         	   = 5;
static const unsigned char TICK_PACKET         	   = 6;
static const unsigned char CHANGE_DIR_PACKET   	   = 7;
static const unsigned char INC_PACKET          	   = 8;
static const unsigned char FOOD_PACKET         	   = 9;
static const unsigned char SPEED_PACKET        	   = 10;
static const unsigned char RESET_PACKET        	   = 11;
static const unsigned char FINE_TUNE_PACKET    	   = 12;
static const unsigned char PAUSE_PACKET        	   = 13;
static const unsigned char TOGGLE_FINE_TUNE_PACKET = 14;

bool sendPacket_Assign(TCPsocket socket, unsigned char snake);
bool recvPacket_Assign(TCPsocket socket, unsigned char* snake);
bool sendPacket_SnakeConfig(TCPsocket socket, unsigned char snake);
bool recvPacket_SnakeConfig(TCPsocket socket, unsigned char* snake);
bool sendPacket_BoardConfig(TCPsocket socket);
bool recvPacket_BoardConfig(TCPsocket socket, int* food);
bool sendPacket_Start(TCPsocket socket);
inline bool recvPacket_Start(TCPsocket socket) {return true;};
bool sendPacket_Stop(TCPsocket socket);
inline bool recvPacket_Stop(TCPsocket socket) {return true;};
bool sendPacket_Tick(TCPsocket socket);
inline bool recvPacket_Tick(TCPsocket socket) {return true;};
bool sendPacket_ChangeDir(TCPsocket socket, unsigned char snake, direction dir);
bool recvPacket_ChangeDir(TCPsocket socket, unsigned char* snake, direction* dir);
bool sendPacket_Inc(TCPsocket socket, unsigned char snake);
bool recvPacket_Inc(TCPsocket socket, unsigned char* snake);
bool sendPacket_Food(TCPsocket socket);
bool recvPacket_Food(TCPsocket socket, int* food);
bool sendPacket_Speed(TCPsocket socket);
bool recvPacket_Speed(TCPsocket socket, unsigned char* speed);
bool sendPacket_Reset(TCPsocket socket);
inline bool recvPacket_Reset(TCPsocket socket) {return true;};
bool sendPacket_FineTune(TCPsocket socket, unsigned char amount);
bool recvPacket_FineTune(TCPsocket socket, unsigned char* amount);
bool sendPacket_Pause(TCPsocket socket, unsigned char pause);
bool recvPacket_Pause(TCPsocket socket, unsigned char* pause);
bool sendPacket_ToggleFineTune(TCPsocket socket, unsigned char fineTune);
bool recvPacket_ToggleFineTune(TCPsocket socket, unsigned char* fineTune);

#endif

