/*  
 *  snake3d, a snake game in a 3d world.
 *  Copyright (C) 2005-2006 Yair Yarom
 *  
 *  This program is free software; you can redistribute it and/or modify it under
 *  the terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option) any later
 *  version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along with
 *  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *  Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 *  http://sourceforge.net/projects/worms3d
 *  
 */

#ifndef PREFERENCES_HPP
#define PREFERENCES_HPP

#include "includes.hpp"
#include "consts.hpp"
#include "network.hpp"

typedef struct Preferences {
    float boardRotationMatrix[16];
    //char keys[NKEYS];
    //int keysMod[NKEYS];
    SDL_keysym SDLkeys[NKEYS];
    float fieldOfView;
    int gridLevel1;
    int gridLevel3;
    bool showWalls;
    bool fullscreen;
    int backgroundColor;
    int stepInterval;
    int windowSize[2];
    int realWindowSize[2];
    int fullScreenResolution[2];
    int currentBoard;
    int currentBoardType;
    int resolution;
    ai_t ai[MAX_SNAKES];
    aiTarget_t aiTarget[MAX_SNAKES];
    int aitSnake[MAX_SNAKES];
    int snakeColor[MAX_SNAKES];
    Uint32 serverPort;
    ip_t clientConnection;
    bool fineTune;
    bool showIndicator;
    char name[20];
} Preferences;

void getPreferences(bool reshape);

void defaultPreferences(bool reshape);
void defaultRotation(bool reshape);
void defaultKeys();

bool loadPreferences(bool reshape);
bool savePreferences();

#endif // PREFERENCES_HPP
