/*  
 *  snake3d, a snake game in a 3d world.
 *  Copyright (C) 2005-2006 Yair Yarom
 *  
 *  This program is free software; you can redistribute it and/or modify it under
 *  the terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option) any later
 *  version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along with
 *  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *  Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 *  http://sourceforge.net/projects/worms3d
 *  
 */

#ifndef TYPES_HPP
#define TYPES_HPP

enum direction {
    left     = 0,
    down     = 1,
    right    = 2,
    up       = 3,
    forward  = 4,
    backward = 5
};

enum playMode_t {
    pm_menu,
    pm_game,
    pm_quit
};

// NKEYS
typedef enum {
    k_moveLeft,
    k_moveDown,
    k_moveRight,
    k_moveUp,
    k_moveForward,
    k_moveBackward,
    k_selfMoveLeft,
    k_selfMoveDown,
    k_selfMoveRight,
    k_selfMoveUp,
    k_selfYawLeft,
    k_selfYawRight,
    k_boardRotateLeft,
    k_boardRotateDown,
    k_boardRotateRight,
    k_boardRotateUp,
    k_boardYawLeft,
    k_boardYawRight,
    k_zoomIn,
    k_zoomOut,
    k_grid1,
    k_grid3,
    k_autoPilot,
    k_resetBoard,
    k_resetSnakes,
    k_backgroundColor,
    k_speedUp,
    k_speedDown,
    k_showWalls,
    k_fullScreen,
    k_lighting,
    k_pause,
    k_quit,
    k_abort,
    k_indicator
} keys_t;

typedef struct State {
    unsigned char boardRotation;
    bool boardRotating[6];
    bool boardZoom[2];
    //    bool changeSpeed[2];
} State;

typedef enum {
    ai_off,
    ai_human,
    ai_basic,

    ai_remote,
    ai_safe,
    ai_switch
} ai_t;

typedef enum {
    ait_food,
    ait_head,
    ait_tail
} aiTarget_t;

typedef enum {
    o_empty,
    o_food,
    o_snake,
    o_intercept,
    o_outside
} occupancy_t;
    
struct Preferences;

#ifdef DEBUG
#define DEBUG_PRINT(X) {printf(X);}
#define DEBUG_PRINT2(X, Y) {printf(X, Y);}
#define DEBUG_PRINT3(X, Y, Z) {printf(X, Y, Z);}
#define FPS 50
#else
#define DEBUG_PRINT(X) {}
#define DEBUG_PRINT2(X, Y) {}
#define DEBUG_PRINT3(X, Y, Z) {}
#endif

//#define FPS 50

#endif
