/*  
 *  snake3d, a snake game in a 3d world.
 *  Copyright (C) 2005-2006 Yair Yarom
 *  
 *  This program is free software; you can redistribute it and/or modify it under
 *  the terms of the GNU General Public License as published by the Free Software
 *  Foundation; either version 2 of the License, or (at your option) any later
 *  version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along with
 *  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *  Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 *  http://sourceforge.net/projects/worms3d
 *  
 */

#include <stdlib.h>
#include <string.h>

#include "userInput.hpp"

bool userInput = false;
userInput_t inputType;
char userString[255];

void beginUserInput(userInput_t type) {
    userInput = true;
    inputType = type;
    userString[0] = 0;
}

void endUserInput(Uint32* result) {
    userInput = false;
    *result = atoi(userString);
    userString[0] = 0;
}

void endUserInput(char* result, int length) {
    userInput = false;
    strncpy(result, userString, length);
    userString[0] = 0;
}


void endUserInput(char* result) {
    userInput = false;
    strcpy(result, userString);
    userString[0] = 0;
}

void endUserInput() {
    userInput = false;
    userString[0] = 0;
}

void inputKey(SDL_keysym key) {
    char str[255];
    char input = 0;
    int length = strlen(userString);

    // backspace
    if (key.sym == SDLK_BACKSPACE) {
	if (length > 0)
	    userString[length - 1] = 0;
	return;
    }

    // full
    if (length == 255)
	return;

    // keypad
    if (key.sym >= SDLK_KP0 &&
	key.sym <= SDLK_KP9)
	key.sym = (SDLKey)(key.sym - (SDLK_KP0 - SDLK_0));
    if (key.sym == SDLK_KP_PERIOD)
	key.sym = SDLK_PERIOD;

    // get input
    strncpy(str, SDL_GetKeyName(key.sym), 255);

    // check upper case
    if ((key.mod & KMOD_SHIFT) && str[0] > 'a' && str[0] < 'z') {
	str[0] += 'A' - 'a';
    }
    switch (inputType) {
      case digits:
	  if (strlen(str) == 1 &&
	      str[0] <= '9' &&
	      str[0] >= '0')
	      input = str[0];
	  break;

      case dotDigits:
	  if (strlen(str) == 1 &&
	      (str[0] <= '9' &&
	       str[0] >= '0') ||
	      (str[0] == '.'))
	      input = str[0];
	  break;
	  
      case letters:
	  if (strlen(str) == 1)
	      input = str[0];
    }
    
    // bad input
    if (input == 0)
	return;

    // fill input
    userString[length] = input;
    userString[length + 1] = 0;
}

void getInput(char* str) {
    snprintf(str, 255, "%s_", userString);
    //strcpy(str, userString);
}

bool inputMode() {
    return userInput;
}
